diff --git a/src/main/java/net/minecraft/core/block/tag/BlockTags.java b/src/main/java/net/minecraft/core/block/tag/BlockTags.java
index b2a4e806b..bbe98ef7c 100644
--- a/src/main/java/net/minecraft/core/block/tag/BlockTags.java
+++ b/src/main/java/net/minecraft/core/block/tag/BlockTags.java
@@ -1,5 +1,7 @@
 package net.minecraft.core.block.tag;
 
+import com.mojang.logging.LogUtils;
+import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.CactusBlock;
 import net.minecraft.core.block.ChainlinkFenceBlock;
@@ -20,6 +22,7 @@ import net.minecraft.core.item.tool.HoeToolItem;
 import net.minecraft.core.item.tool.PickaxeToolItem;
 import net.minecraft.core.item.tool.ShovelToolItem;
 import net.minecraft.core.item.tool.SwordToolItem;
+import org.slf4j.Logger;
 
 import java.lang.reflect.Field;
 import java.util.ArrayList;
@@ -30,6 +33,7 @@ import java.util.List;
  */
 public abstract class BlockTags
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
     /**
      * block can be mined by {@link PickaxeToolItem PickaxeToolItem}.
      */
@@ -108,7 +112,7 @@ public abstract class BlockTags
      */
     public static Tag<Block> SHEARS_DO_SILK_TOUCH = Tag.of("shears_do_silk_touch");
     /**
-     * This block can be skated on using {@link net.minecraft.core.item.Item#ARMOR_BOOTS_ICESKATES ice skates}.
+     * This block can be skated on using {@link net.minecraft.core.item.Items#ARMOR_BOOTS_ICESKATES ice skates}.
      */
     public static Tag<Block> SKATEABLE = Tag.of("skateable");
     /**
@@ -151,6 +155,18 @@ public abstract class BlockTags
      * Block extends the range of a motion sensor's sight.
      */
     public static Tag<Block> EXTENDS_MOTION_SENSOR_RANGE = Tag.of("extends_motion_sensor_range");
+    /**
+     * When broken, items go into the player's inventory immediately instead of being dropped
+     */
+    public static Tag<Block> INSTANT_PICKUP = Tag.of("instant_pickup");
+    /**
+     * Sheep will follow the player if they are holding this block.
+     */
+    public static Tag<Block> SHEEPS_FAVOURITE_BLOCK = Tag.of("sheeps_favourite_block");
+    /**
+     * Pigs will follow the player if they are holding this block.
+     */
+    public static Tag<Block> PIGS_FAVOURITE_BLOCK = Tag.of("pigs_favourite_block");
 
     public static List<Tag<Block>> TAG_LIST;
 
@@ -168,7 +184,7 @@ public abstract class BlockTags
                 }
                 catch (Exception e)
                 {
-                    e.printStackTrace();
+                    LOGGER.error("Failed to add tag '{}'!", field.getName(), e);
                 }
             }
         }
diff --git a/src/main/java/net/minecraft/core/data/DataLoader.java b/src/main/java/net/minecraft/core/data/DataLoader.java
index cc6e57c74..a634f9547 100644
--- a/src/main/java/net/minecraft/core/data/DataLoader.java
+++ b/src/main/java/net/minecraft/core/data/DataLoader.java
@@ -4,6 +4,7 @@ import com.b100.utils.FileUtils;
 import com.b100.utils.StringUtils;
 import com.google.gson.*;
 import com.google.gson.reflect.TypeToken;
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.MinecraftAccessor;
 import net.minecraft.core.WeightedRandomBag;
 import net.minecraft.core.WeightedRandomLootObject;
@@ -14,6 +15,7 @@ import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.data.registry.recipe.adapter.*;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.RecipeSyncPacket;
+import org.slf4j.Logger;
 
 import java.io.*;
 import java.lang.reflect.InvocationTargetException;
@@ -25,7 +27,7 @@ import java.util.zip.ZipEntry;
 import java.util.zip.ZipFile;
 
 public class DataLoader {
-
+    private static final Logger LOGGER = LogUtils.getLogger();
     public static void loadItemGroupsFromString(String json){
         int i = 0;
         GsonBuilder builder = new GsonBuilder();
@@ -39,7 +41,7 @@ public class DataLoader {
             Registries.ITEM_GROUPS.register(entry.getKey(),stacks);
             i++;
         }
-        System.out.printf("Registered %d item groups%n",i);
+        LOGGER.info("Registered {} item groups",i);
     }
 
     public static void loadItemGroupsFromFile(String path){
@@ -56,7 +58,7 @@ public class DataLoader {
             Registries.ITEM_GROUPS.register(entry.getKey(),stacks);
             i++;
         }
-        System.out.printf("Registered %d item groups from %s%n",i,path);
+        LOGGER.info("Registered {} item groups from {}",i,path);
     }
 
     public static void loadDataPacks(MinecraftAccessor mc){
@@ -73,7 +75,7 @@ public class DataLoader {
                     }
                     try {
                         try (ZipFile zipFile = new ZipFile(file)) {
-                            System.out.printf("Loading data from %s%n",file.getName());
+                            LOGGER.info("Loading data from {}",file.getName());
                             ZipEntry manifestEntry = zipFile.getEntry("manifest.json");
                             if(manifestEntry != null){
                                 try (InputStreamReader reader = new InputStreamReader(zipFile.getInputStream(manifestEntry))) {
@@ -88,7 +90,7 @@ public class DataLoader {
                                             String[] deconstructedKey = Registries.RECIPES.deconstructKey(removedRecipe);
                                             Registries.RECIPES.getGroupFromKey(removedRecipe).unregister(deconstructedKey[2]);
                                         }
-                                        System.out.printf("Removed %d recipes%n",removedRecipes.size());
+                                        LOGGER.info("Removed {} recipes",removedRecipes.size());
                                     }
                                     //let groups load first
                                     if(groupFiles != null && !groupFiles.isEmpty()){
@@ -97,7 +99,7 @@ public class DataLoader {
                                             if(groupFileEntry != null){
                                                 try (InputStream recipeFileInputStream = zipFile.getInputStream(groupFileEntry)) {
                                                     String contents = StringUtils.readInputString(recipeFileInputStream);
-                                                    System.out.printf("Loading item groups from %s/%s%n",file.getName(),groupFile);
+                                                    LOGGER.info("Loading item groups from {}/{}",file.getName(),groupFile);
                                                     loadItemGroupsFromString(contents);
                                                 }
                                             }
@@ -110,7 +112,7 @@ public class DataLoader {
                                             if(recipeFileEntry != null){
                                                 try (InputStream recipeFileInputStream = zipFile.getInputStream(recipeFileEntry)) {
                                                     String contents = StringUtils.readInputString(recipeFileInputStream);
-                                                    System.out.printf("Loading recipes from %s/%s%n",file.getName(),recipeFile);
+                                                    LOGGER.info("Loading recipes from {}/{}",file.getName(),recipeFile);
                                                     loadRecipesFromString(contents);
                                                 }
                                             }
@@ -120,8 +122,7 @@ public class DataLoader {
                             }
                         }
                     } catch (IOException | RuntimeException e){
-                        System.err.println("Failed to load data from "+file.getName());
-                        e.printStackTrace();
+                        LOGGER.error("Failed to load data from {}", file.getName(), e);
                     }
                 }
             }
@@ -163,7 +164,7 @@ public class DataLoader {
             Registries.RECIPES.addCustomRecipe(recipeId,recipe);
             i++;
         }
-        System.out.printf("Registered %d recipes from %s%n",i,path);
+        LOGGER.info("Registered {} recipes from {}",i,path);
     }
 
     public static void loadRecipesFromString(String json){
@@ -200,7 +201,7 @@ public class DataLoader {
             Registries.RECIPES.addCustomRecipe(recipeId,recipe);
             i++;
         }
-        System.out.printf("Registered %d recipes%n",i);
+        LOGGER.info("Registered {} recipes",i);
     }
 
     public static void loadRecipeFromServer(RecipeSyncPacket packet){
@@ -230,7 +231,7 @@ public class DataLoader {
         Gson gson = builder.create();
         RecipeEntryBase<?, ?, ?> recipe = gson.fromJson(recipeJson, recipeEntryClass);
         Registries.RECIPES.addCustomRecipe(recipeId,recipe);
-        //System.out.printf("Received recipe '%s' from server%n",recipeId);
+        //System.out.printf("Received recipe '%s' from server",recipeId);
     }
 
     public static String serializeRecipes(){
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java b/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
index 6424f12d0..ae90a6116 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
@@ -7,17 +7,18 @@ import com.google.gson.JsonObject;
 import com.google.gson.JsonParseException;
 import com.google.gson.JsonSerializationContext;
 import com.google.gson.JsonSerializer;
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.Item;
-import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.HardIllegalArgumentException;
 import net.minecraft.core.util.collection.NamespaceID;
+import org.slf4j.Logger;
 
 import java.lang.reflect.Type;
 
 public class ItemStackJsonAdapter implements JsonDeserializer<ItemStack>, JsonSerializer<ItemStack> {
+    private static final Logger LOGGER = LogUtils.getLogger();
     @Override
     public ItemStack deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
         JsonObject obj = json.getAsJsonObject();
@@ -34,7 +35,7 @@ public class ItemStackJsonAdapter implements JsonDeserializer<ItemStack>, JsonSe
                     throw new IllegalArgumentException("Item keys must either start with 'tile' or 'item' provided key '" + key + "' does not!");
                 }
             } catch (Exception e){
-                System.out.println("Failed to find item for key '" + key + "'!");
+                LOGGER.warn("Failed to find item for key '{}'!", key);
                 throw new IllegalArgumentException("Failed to find item for key '" + key + "'!\n" + e.getMessage());
             }
         } else {
diff --git a/src/main/java/net/minecraft/core/entity/EntityDispatcher.java b/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
index d33dc2a93..3cf341baf 100644
--- a/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
+++ b/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.entity;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.entity.animal.*;
 import net.minecraft.core.entity.monster.*;
 import net.minecraft.core.entity.projectile.*;
@@ -7,13 +8,14 @@ import net.minecraft.core.entity.vehicle.BoatEntity;
 import net.minecraft.core.entity.vehicle.MinecartEntity;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.World;
+import org.slf4j.Logger;
 
 import java.util.HashMap;
 import java.util.Map;
 
 public class EntityDispatcher
 {
-
+    private static final Logger LOGGER = LogUtils.getLogger();
     public EntityDispatcher()
     {
     }
@@ -26,12 +28,12 @@ public class EntityDispatcher
         classToIdMap.put(clazz, id);
     }
 
-    public static Entity createEntityInWorld(String s, World world)
+    public static Entity createEntityInWorld(String id, World world)
     {
         Entity entity = null;
         try
         {
-            Class<? extends Entity> clazz = keyToClassMap.get(s);
+            Class<? extends Entity> clazz = keyToClassMap.get(id);
             if(clazz != null)
             {
                 entity = clazz.getConstructor(World.class).newInstance(world);
@@ -39,8 +41,7 @@ public class EntityDispatcher
         }
         catch(Exception exception)
         {
-            exception.printStackTrace();
-            System.out.println("Error with id '" + s + "'");
+            LOGGER.error("Failed to instance entity id '{}'!", id, exception);
         }
         return entity;
     }
@@ -58,14 +59,14 @@ public class EntityDispatcher
         }
         catch(Exception exception)
         {
-            exception.printStackTrace();
+            LOGGER.error("Failed to instance entity id '{}'!", compoundTag.getStringOrDefault("id", "UNKNOWN"), exception);
         }
         if(entity != null)
         {
             entity.load(compoundTag);
         } else
         {
-            System.out.println("Skipping Entity with id " + compoundTag.getString("id"));
+            LOGGER.warn("Skipping Entity with id {}", compoundTag.getStringOrDefault("id", "UNKNOWN"));
         }
         return entity;
     }
@@ -82,11 +83,11 @@ public class EntityDispatcher
         }
         catch(Exception exception)
         {
-            exception.printStackTrace();
+            LOGGER.error("Failed to instance entity id '{}'!", id, exception);
         }
         if(entity == null)
         {
-            System.out.println("Skipping Entity with id " + id);
+            LOGGER.warn("Skipping Entity with id {}", id);
         }
         return entity;
     }
diff --git a/src/main/java/net/minecraft/core/entity/animal/Animal.java b/src/main/java/net/minecraft/core/entity/animal/Animal.java
index eabf88600..27a6ef249 100644
--- a/src/main/java/net/minecraft/core/entity/animal/Animal.java
+++ b/src/main/java/net/minecraft/core/entity/animal/Animal.java
@@ -6,7 +6,11 @@ package net.minecraft.core.entity.animal;
 //            MathHelper, AxisAlignedBB, NBTTagCompound
 
 import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.data.tag.Tag;
 import net.minecraft.core.entity.PathfinderMob;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.World;
@@ -24,6 +28,26 @@ public abstract class Animal extends PathfinderMob
         scoreValue = 10;
     }
 
+    @Override
+    protected void updateAI()
+    {
+        Player closest = world.getClosestPlayer(x, y, z, 10);
+        if(closest != null){
+            if(isFavouriteItem(closest.getHeldItem())){
+                setTarget(closest);
+            } else {
+                setTarget(null);
+            }
+        }
+        super.updateAI();
+        if(entityToAttack != null) {
+            float distanceToEntity = entityToAttack.distanceTo(this);
+            if(distanceToEntity < 3) {
+                moveForward = 0;
+            }
+        }
+    }
+
     @Override
 	public int getMaxSpawnedInChunk()
     {
@@ -77,4 +101,8 @@ public abstract class Animal extends PathfinderMob
     {
         return 120;
     }
+
+    public boolean isFavouriteItem(ItemStack itemStack) {
+        return false;
+    }
 }
diff --git a/src/main/java/net/minecraft/core/entity/animal/ChickenMob.java b/src/main/java/net/minecraft/core/entity/animal/ChickenMob.java
index 1fb5661bb..58338031b 100644
--- a/src/main/java/net/minecraft/core/entity/animal/ChickenMob.java
+++ b/src/main/java/net/minecraft/core/entity/animal/ChickenMob.java
@@ -2,7 +2,9 @@ package net.minecraft.core.entity.animal;
 
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.WeightedRandomLootObject;
+import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
+import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.world.World;
 
@@ -98,4 +100,10 @@ public class ChickenMob extends Animal
     {
         return "mob.chickenhurt";
     }
+
+    @Override
+    public boolean isFavouriteItem(ItemStack itemStack)
+    {
+        return itemStack != null && itemStack.getItem().hasTag(ItemTags.CHICKENS_FAVOURITE_ITEM);
+    }
 }
diff --git a/src/main/java/net/minecraft/core/entity/animal/CowMob.java b/src/main/java/net/minecraft/core/entity/animal/CowMob.java
index 8b4c863ed..361b271f8 100644
--- a/src/main/java/net/minecraft/core/entity/animal/CowMob.java
+++ b/src/main/java/net/minecraft/core/entity/animal/CowMob.java
@@ -11,6 +11,7 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.item.EmptyBucketItem;
 import net.minecraft.core.item.ItemStack;
 import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.world.World;
 
@@ -72,4 +73,10 @@ public class CowMob extends Animal
         }
         return super.interact(entityplayer);
     }
+
+    @Override
+    public boolean isFavouriteItem(ItemStack itemStack)
+    {
+        return itemStack != null && itemStack.getItem().hasTag(ItemTags.COWS_FAVOURITE_ITEM);
+    }
 }
diff --git a/src/main/java/net/minecraft/core/entity/animal/PigMob.java b/src/main/java/net/minecraft/core/entity/animal/PigMob.java
index 6dd14e84a..7e0e09b61 100644
--- a/src/main/java/net/minecraft/core/entity/animal/PigMob.java
+++ b/src/main/java/net/minecraft/core/entity/animal/PigMob.java
@@ -8,9 +8,13 @@ package net.minecraft.core.entity.animal;
 
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.achievement.Achievements;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.LightningEntity;
 import net.minecraft.core.entity.monster.ZombiePigMob;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.util.collection.NamespaceID;
@@ -139,5 +143,13 @@ public class PigMob extends Animal
             ((Player) passenger).triggerAchievement(Achievements.FLY_PIG);
         }
     }
+    @Override
+    public boolean isFavouriteItem(ItemStack itemStack)
+    {
+        if(itemStack == null || itemStack.itemID >= Block.blocksList.length)
+            return false;
+
+        return Block.blocksList[itemStack.itemID].hasTag(BlockTags.PIGS_FAVOURITE_BLOCK);
+    }
     public List<WeightedRandomLootObject> burningMobDrops = new ArrayList<>();
 }
diff --git a/src/main/java/net/minecraft/core/entity/animal/SheepMob.java b/src/main/java/net/minecraft/core/entity/animal/SheepMob.java
index 4055780ce..b8df24232 100644
--- a/src/main/java/net/minecraft/core/entity/animal/SheepMob.java
+++ b/src/main/java/net/minecraft/core/entity/animal/SheepMob.java
@@ -3,6 +3,7 @@ package net.minecraft.core.entity.animal;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.ItemEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
@@ -258,6 +259,15 @@ public class SheepMob extends Animal
         {  0.1F,  0.1F,  0.1F  }  // Black
     };
 
+    @Override
+    public boolean isFavouriteItem(ItemStack itemStack)
+    {
+        if(itemStack == null || itemStack.itemID >= Block.blocksList.length)
+            return false;
+
+        return Block.blocksList[itemStack.itemID].hasTag(BlockTags.SHEEPS_FAVOURITE_BLOCK);
+    }
+
     public void setGrowthTimer(int growthTimer){
         this.growthTimer = growthTimer;
     }
diff --git a/src/main/java/net/minecraft/core/entity/animal/WolfMob.java b/src/main/java/net/minecraft/core/entity/animal/WolfMob.java
index ac4f3abc3..6a1305ce7 100644
--- a/src/main/java/net/minecraft/core/entity/animal/WolfMob.java
+++ b/src/main/java/net/minecraft/core/entity/animal/WolfMob.java
@@ -11,6 +11,7 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.material.ArmorMaterial;
+import net.minecraft.core.util.helper.UUIDHelper;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.CompoundTag;
@@ -29,6 +30,7 @@ import java.util.*;
 
 public class WolfMob extends Animal
 {
+    public static final int DATA_OWNER_UUID = 17;
 
     public WolfMob(World world)
     {
@@ -50,9 +52,9 @@ public class WolfMob extends Animal
 	protected void defineSynchedData()
     {
         super.defineSynchedData();
-        entityData.define(15, ItemStack.NO_ITEM);
+        entityData.define(15, ItemStack.class);
         entityData.define(16, (byte) 0);
-        entityData.define(17, "");
+        entityData.define(DATA_OWNER_UUID, UUID.class);
         entityData.define(19, "");
     }
     @Override
@@ -76,7 +78,6 @@ public class WolfMob extends Animal
     public void setArmor(ItemStack stack) {
         ArmorMaterial material = null;
         armor = stack;
-        //noinspection SuspiciousMethodCalls
         if (stack != null && stack.getItem() instanceof IArmorItem && ARMOR_MATERIALS.containsValue(stack.getItem())){
             material = ((IArmorItem) stack.getItem()).getArmorMaterial();
         }
@@ -133,7 +134,7 @@ public class WolfMob extends Animal
         if (entity instanceof Player)
         {
             Player player = (Player) entity;
-            return !player.username.equalsIgnoreCase(getWolfOwner()) || isWolfSitting();
+            return !player.uuid.equals(getWolfOwner()) || isWolfSitting();
         }
 
         return true;
@@ -157,13 +158,7 @@ public class WolfMob extends Animal
             armor.writeToNBT(armorTag);
             tag.putCompound("Armor", armorTag);
         }
-        if(getWolfOwner() == null)
-        {
-            tag.putString("Owner", "");
-        } else
-        {
-            tag.putString("Owner", getWolfOwner());
-        }
+        UUIDHelper.writeToTag(tag, getWolfOwner(), "OwnerUUID");
     }
 
     @Override
@@ -204,10 +199,16 @@ public class WolfMob extends Animal
 
         }
 
-        String s = tag.getString("Owner");
-        if(!s.isEmpty())
-        {
-            setWolfOwner(s);
+        UUID ownerUUID = UUIDHelper.readFromTag(tag, "OwnerUUID");
+        if (ownerUUID == null) {
+            String s = tag.getString("Owner");
+            if (!s.isEmpty()) {
+                UUIDHelper.runConversionAction(s,
+                    (uuid) -> {setWolfOwner(uuid); setWolfTamed(true);},
+                    null);
+            }
+        } else {
+            setWolfOwner(ownerUUID);
             setWolfTamed(true);
         }
     }
@@ -287,7 +288,7 @@ public class WolfMob extends Animal
 
         if(!hasAttacked && !hasPath() && isWolfTamed() && vehicle == null)
         {
-            Player entityplayer = world.getPlayerEntityByName(getWolfOwner());
+            Player entityplayer = world.getPlayerEntityByUUID(getWolfOwner());
             if(entityplayer != null)
             {
                 float f = entityplayer.distanceTo(this);
@@ -296,15 +297,15 @@ public class WolfMob extends Animal
                     getPathOrWalkableBlock(entityplayer, f);
                 }
             } else
-            if(!isInWater())
+            if(isInWater())
             {
-                setWolfSitting(true);
+                setWolfSitting(false);
             }
         } else
         if(entityToAttack == null && !hasPath())
         {
             if(!isWolfTamed() && world.rand.nextInt(100) == 0){
-                List nearbySheep = world.getEntitiesWithinAABB(SheepMob.class, AABB.getTemporaryBB(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
+                List<Entity> nearbySheep = world.getEntitiesWithinAABB(SheepMob.class, AABB.getTemporaryBB(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
                 if (!nearbySheep.isEmpty()) {
                     setTarget((Entity) nearbySheep.get(world.rand.nextInt(nearbySheep.size())));
                 }
@@ -557,15 +558,15 @@ public class WolfMob extends Animal
                 }
                 if(attacker instanceof Mob)
                 {
-                    List list = world.getEntitiesWithinAABB(WolfMob.class, AABB.getTemporaryBB(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
-                    Iterator iterator = list.iterator();
+                    List<Entity> list = world.getEntitiesWithinAABB(WolfMob.class, AABB.getTemporaryBB(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
+                    Iterator<Entity> iterator = list.iterator();
                     do
                     {
                         if(!iterator.hasNext())
                         {
                             break;
                         }
-                        Entity entity1 = (Entity)iterator.next();
+                        Entity entity1 = iterator.next();
                         WolfMob entitywolf = (WolfMob)entity1;
                         if(!entitywolf.isWolfTamed() && entitywolf.entityToAttack == null)
                         {
@@ -580,7 +581,7 @@ public class WolfMob extends Animal
             } else
             if(attacker != this && attacker != null)
             {
-                if(isWolfTamed() && (attacker instanceof Player) && ((Player) attacker).username.equalsIgnoreCase(getWolfOwner()))
+                if(isWolfTamed() && (attacker instanceof Player) && ((Player) attacker).uuid.equals(getWolfOwner()))
                 {
                     return true;
                 }
@@ -674,7 +675,7 @@ public class WolfMob extends Animal
                         setPathToEntity(null);
                         setWolfSitting(true);
                         setHealthRaw(getMaxHealth());
-                        setWolfOwner(entityplayer.username);
+                        setWolfOwner(entityplayer.uuid);
                         showHeartsOrSmokeFX(true);
                         world.sendTrackedEntityStatusUpdatePacket(this, (byte)7);
                     } else
@@ -704,7 +705,7 @@ public class WolfMob extends Animal
                     return true;
                 }
             }
-            if (itemstack != null && itemstack.getItem() instanceof IArmorItem && entityplayer.username.equalsIgnoreCase(getWolfOwner())) {
+            if (itemstack != null && itemstack.getItem() instanceof IArmorItem && entityplayer.uuid.equals(getWolfOwner())) {
                 IArmorItem armorItem = (IArmorItem) itemstack.getItem();
                 if (armorItem.getArmorMaterial() != null && ARMOR_MATERIALS.containsValue(armorItem)) {
                     if (armor != null) {
@@ -721,7 +722,7 @@ public class WolfMob extends Animal
                     return true;
                 }
             }
-            if(entityplayer.username.equalsIgnoreCase(getWolfOwner()))
+            if(entityplayer.uuid.equals(getWolfOwner()))
             {
                 if(!world.isClientSide)
                 {
@@ -789,14 +790,14 @@ public class WolfMob extends Animal
         }
     }
 
-    public String getWolfOwner()
+    public UUID getWolfOwner()
     {
-        return entityData.getString(17);
+        return entityData.getUUID(DATA_OWNER_UUID);
     }
 
-    public void setWolfOwner(String s)
+    public void setWolfOwner(UUID uuid)
     {
-        entityData.set(17, s);
+        entityData.set(DATA_OWNER_UUID, uuid);
     }
 
     public boolean isWolfSitting()
@@ -834,17 +835,10 @@ public class WolfMob extends Animal
     }
 
     public ItemStack getWolfHeldItem(){
-        ItemStack stack = entityData.getItemStack(15);
-        if (stack == ItemStack.NO_ITEM){
-            stack = null;
-        }
-        return stack;
+        return entityData.getItemStack(15);
     }
 
     public void setWolfHeldItem(ItemStack itemStack){
-        if (itemStack == null){
-            itemStack = ItemStack.NO_ITEM;
-        }
         entityData.set(15, itemStack);
     }
 
